/**
 * Copyright (C) 2011 Agrosense <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.crop.clm;

/** Jersey REST client generated for REST resource:CropWadl-xml [clm/crop_service.php]<br>
 *  USAGE:<pre>
 *        ClmCropClient client = new ClmCropClient();
 *        Object response = client.XXX(...);
 *        // do whatever with response
 *        client.close();
 *  </pre>
 * @author merijn
 */
public class ClmCropClient {
    private com.sun.jersey.api.client.WebResource webResource;
    private com.sun.jersey.api.client.Client client;
    private static final String BASE_URI = "http://www.agrosense.nl";
    private static final String APP_KEY = "fk234u5g890vufjnmkl3425j354";

    public ClmCropClient() {
        com.sun.jersey.api.client.config.ClientConfig config = new com.sun.jersey.api.client.config.DefaultClientConfig();
        client = com.sun.jersey.api.client.Client.create(config);
        webResource = client.resource(BASE_URI).path("clm/crop_service.php");
    }

    /**
     * @param responseType Class representing the response
     * @param appKey query parameter[REQUIRED]
     * @return response object (instance of responseType class)
     */
    public <T> T getCrops(Class<T> responseType) throws com.sun.jersey.api.client.UniformInterfaceException {
        return webResource.queryParam("appKey", APP_KEY).accept(javax.ws.rs.core.MediaType.TEXT_XML).get(responseType);
    }

    public void close() {
        client.destroy();
    }
    
}
