/**
 * Copyright (C) 2011 Agrosense <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.crop.clm;

import java.util.List;
import org.openide.util.lookup.ServiceProvider;

/**
 * Provides crops from the CLM web service
 * @author Merijn Zengers
 */
@ServiceProvider(service=ClmCropService.class)
public class ClmCropServiceImpl implements ClmCropService{
    
    private ClmCropClient client;
    
    /**
     * Gets a list of crop names  
     * @return List<String> Names of crops
     */
    @Override
    public List<String> getCropNames() {
        client = new ClmCropClient();
        ClmUnmarshaller unmarshaller = new ClmUnmarshaller();
        CropMessage cropMessage = unmarshaller.unMarshall(client.getCrops(String.class));
        client.close();
        
        List<String> cropNames = null;
        
        if(cropMessage != null){
            // TODO: .getCrops().get(0).getCrop() .... Refactor to something that does make sense...
            cropNames = cropMessage.getCrops().get(0).getCrop();
        }
        
        return cropNames;
    }
    
}
